#------------------------------------------------------------------------------------------------
# Permission to use, copy, modify, and distribute this software for 
# any purpose and without fee is hereby granted.
#------------------------------------------------------------------------------------------------
# THIS SOFTWARE IS PROVIDED "AS IS" AND WITHOUT ANY EXPRESS OR
# IMPLIED WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED
# WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.
#------------------------------------------------------------------------------------------------
# IT WAS CREATED AND TESTED IN A WINDOWS ENVIRONMENT ONLY AND MAY NOT FUNCTION ON A MAC.
#------------------------------------------------------------------------------------------------
# THIS PLUGIN IS ANOTHER FIGMENT OF MY IMAGENATION AND IS NOT BASED ON OR COMPLY WITH ANYTHING! 
#------------------------------------------------------------------------------------------------
#  Name:	RoundedRectangle
#    By:	sdmitch
# Usage:	Place a rectangle with rounded corners
#  Date:	May 2011
#------------------------------------------------------------------------------------------------
require 'Sketchup'
# ------------------  MENU SETUP ---------------------- #
unless $sdm_tools_menu
	$sdm_tools_menu = UI.menu("Plugins").add_submenu("Werkzeuge von sdmitch")
	$sdm_Edge_tools = $sdm_tools_menu.add_submenu("Kanten und Linien")
	$sdm_Face_tools = $sdm_tools_menu.add_submenu("Flächen Werkzeuge")
	$sdm_CorG_tools = $sdm_tools_menu.add_submenu("Gruppen und Komponenten")
	$sdm_Misc_tools = $sdm_tools_menu.add_submenu("Diverse Werkzeuge")
end
unless file_loaded?(__FILE__)
	$sdm_Face_tools.add_item("Rechteck mit Runden Ecken") { Sketchup.active_model.select_tool SDM::Round_Corner_Rectangle.new }
	file_loaded(__FILE__)
end
# ------------------------------------------------------ #
module SDM

	class Round_Corner_Rectangle

		def initialize
			@ip = Sketchup::InputPoint.new
			@ip1 = Sketchup::InputPoint.new
			@aMod = Sketchup.active_model
			@aEnt = @aMod.active_entities
			@aSel = @aMod.selection
			@pi = Math::PI
			@rad = 6.inch
			self.reset
		end

		def reset
			@state = 0
			@ip1.clear
			@drawn = false
			@aSel.clear
			Sketchup::set_status_text("Waehle Erste Ecke", SB_PROMPT)
			Sketchup::set_status_text("", SB_VCB_LABEL)
			Sketchup::set_status_text("", SB_VCB_VALUE)
		end

		def onMouseMove(flags, x, y, view)
			self.set_current_point(x, y, view)
			ph = view.pick_helper
			ph.do_pick(x, y)
			view.refresh
			Sketchup::set_status_text("Waehle Zweite Ecke", SB_PROMPT) if @state==0
		end

		def set_current_point(x, y, view)
			if( !@ip.pick(view, x, y, @ip1) )
				return false
			end
			@ip1.copy! @ip
			@pt2 = @ip.position
			self.box if @state==1
			view.tooltip = @ip.tooltip     
			view.refresh
		end

		def onLButtonDown(flags, x, y, view)
			self.set_current_point(x, y, view)
			cpt=@aEnt.add_cpoint(@pt2) if $sdm_debug
			self.increment_state
			view.lock_inference
		end
		
		def increment_state
			@state += 1
			case @state
				when 1
					@pt1 = @ip.position
					Sketchup::set_status_text "Finde Ecke Gegenueber"
					Sketchup::set_status_text "", SB_VCB_LABEL
					Sketchup::set_status_text "", SB_VCB_VALUE
				when 2	
					puts "llc=#{@llc}\nulc=#{@ulc}\nurc=#{@urc}\nlrc=#{@lrc}" if $sdm_debug
					self.add_rcr #if (UI.messagebox("Accept?", MB_YESNO)==6)
					self.reset
			end
		end
		
		def box
			xlo = [@pt1.x,@pt2.x].min
			ylo = [@pt1.y,@pt2.y].min
			xhi = [@pt1.x,@pt2.x].max
			yhi = [@pt1.y,@pt2.y].max
			@llc=[xlo,ylo,0]
			@ulc=[xlo,yhi,0]
			@urc=[xhi,yhi,0]
			@lrc=[xhi,ylo,0]
		end
		
		def add_rcr
			@aMod.start_operation "Add RCR"
			vx=[1,0,0];vy=[0,1,0];vz=[0,0,1]
			ans=UI.inputbox(["Ecke Radius:"],[@rad],"Rechteck Runden")
			if !ans
				Sketchup.send_action "selectSelectionTool:"
				return nil
			end
			rad=ans[0].to_l; @rad=rad
			if (@llc.distance(@ulc) >= @rad*2 && @ulc.distance(@urc) >= @rad*2) then
				# lower left corner
				ctr=Geom::Point3d.new(@llc.x+rad,@llc.y+rad,0)
				arc=@aEnt.add_arc(ctr,vx,vz,rad,@pi,@pi*1.5,6)
				@aSel.add arc
				cpt=@aEnt.add_cpoint(ctr) if $sdm_debug
				# left side
				pt1=Geom::Point3d.new(@llc.x,@llc.y+rad,0);pt2=Geom::Point3d.new(@ulc.x,@ulc.y-rad,0)
				edg=@aEnt.add_line(pt1,pt2); @aSel.add edg
				# upper left corner
				ctr=Geom::Point3d.new(@ulc.x+rad,@ulc.y-rad,0)
				arc=@aEnt.add_arc(ctr,vx,vz,rad,@pi*0.5,@pi,6)
				@aSel.add arc
				cpt=@aEnt.add_cpoint(ctr) if $sdm_debug
				# top side
				pt1=Geom::Point3d.new(@ulc.x+rad,@ulc.y,0);pt2=Geom::Point3d.new(@urc.x-rad,@urc.y,0)
				edg=@aEnt.add_line(pt1,pt2); @aSel.add edg
				# upper right corner
				ctr=Geom::Point3d.new(@urc.x-rad,@urc.y-rad,0)
				arc=@aEnt.add_arc(ctr,vx,vz,rad,0,@pi*0.5,6)
				@aSel.add arc
				cpt=@aEnt.add_cpoint(ctr) if $sdm_debug
				# right side
				pt1=Geom::Point3d.new(@urc.x,@urc.y-rad,0);pt2=Geom::Point3d.new(@lrc.x,@lrc.y+rad,0)
				edg=@aEnt.add_line(pt1,pt2); @aSel.add edg
				# lower right corner
				ctr=Geom::Point3d.new(@lrc.x-rad,@lrc.y+rad,0)
				arc=@aEnt.add_arc(ctr,vx,vz,rad,@pi*1.5,@pi*2.0,6)
				@aSel.add arc
				cpt=@aEnt.add_cpoint(ctr) if $sdm_debug
				# bottom side
				pt1=Geom::Point3d.new(@lrc.x-rad,@lrc.y,0);pt2=Geom::Point3d.new(@llc.x+rad,@llc.y,0)
				edg=@aEnt.add_line(pt1,pt2); @aSel.add edg
				edg.find_faces
				@aMod.commit_operation
			else
				UI.messagebox "Rechteck ist zu klein fuer einen Radius von #{rad}"
			end
			
		end
		
		def onCancel(flag, view)
			view.refresh if @drawn
			Sketchup.send_action "selectSelectionTool:"
		end
		
		def onRButtonDown(flags, x, y, view)
			@state==0 ? onCancel(flags,view) : self.reset
		end

		def draw(view)
			@drawn = false
			# Show the current input point
			if( @ip.valid? && @ip.display? ) then
				@ip.draw(view)
				@drawn = true
			end
			if( @state == 1 )
				view.drawing_color = "magenta"
				inference_locked = view.inference_locked?
				view.line_width = 3 #if inference_locked
				view.draw(GL_LINE_LOOP, @llc,@ulc,@urc,@lrc)
				view.line_width = 1 #if inference_locked
				@drawn = true
			end
		end
		
	end # of class AddRCR
	
end
